﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ServiceContract.Dtos;

namespace Client
{
    public partial class ProductsForm 
        : Form, IProductsView
    {
        private EventHandler onSearchProductsDelegate;

        public ProductsForm()
        {
            InitializeComponent();
        }

        #region IProductsView Members

        string IProductsView.ProductNameQuery
        {
            get
            {
                return textBox1.Text;
            }
            set
            {
                textBox1.Text = value;
            }
        }

        event EventHandler IProductsView.OnSearchProducts
        {
            add 
            {
                onSearchProductsDelegate += value;
            }
            remove
            {
                onSearchProductsDelegate -= value;
            }
        }

        List<ProductDto> IProductsView.DisplayedProducts
        {
            get
            {
                return dataGridView1.DataSource as List<ProductDto>;
            }
            set
            {
                dataGridView1.DataSource = value;
            }
        }      

        #endregion

        private void button1_Click(object sender, EventArgs e)
        {
            FireOnSearchProducts();
        }

        private void FireOnSearchProducts()
        {
            if (onSearchProductsDelegate != null)
            {
                onSearchProductsDelegate(this, EventArgs.Empty);
            }
        }

    }
}
