﻿using System;
using System.Collections.Generic;
using System.Text;
using ServiceContract.Interface;
using ServiceContract.Requests;
using ServiceContract.Responses;
using ServiceContract.Dtos;

namespace Client
{
    public class ProductsPresenter
    {
        private IProductsView view;
        private IProductService productService;

        public ProductsPresenter(IProductsView view, IProductService productService)
        {
            this.view = view;
            this.productService = productService;
            view.OnSearchProducts += new EventHandler(SearchProducts);
        }

        void SearchProducts(object sender, EventArgs e)
        {
            string searchQuery = view.ProductNameQuery;
            List<ProductDto> products = null;
            if (string.IsNullOrEmpty(searchQuery))
            {
                RetrieveProductsResponse response = productService.RetrieveProducts(new RetrieveProductsRequest());
                products = response.Products;
            }
            else
            {
                SearchProductsResponse response = productService.SearchProducts(new SearchProductsRequest(searchQuery));
                products = response.Products;
            }
            view.DisplayedProducts = products;
        }        
    }
}
