﻿using System;
using System.Collections.Generic;
using System.Text;
using ServiceContract.Interface;
using ServiceContract.Responses;
using ServiceContract.Requests;
using ServiceContract.Dtos;

namespace Service
{
    public class ProductService
        : IProductService
    {
        private List<ProductDto> products;

        public ProductService()
        {
            products = new List<ProductDto>();
            products.Add(new ProductDto("Pizza Margherita",9.75));
            products.Add(new ProductDto("Pizza Pepperoni Lovers",10.95));
            products.Add(new ProductDto("Pizza Cheesam ",10.95));
        }

        #region IProductService Members

        public RetrieveProductsResponse RetrieveProducts(RetrieveProductsRequest request)
        {
            return new RetrieveProductsResponse(products);
        }

        public SearchProductsResponse SearchProducts(SearchProductsRequest request)
        {
            List<ProductDto> productMatches = new List<ProductDto>();
            foreach (ProductDto product in products)
            {
                if (product.Name.ToUpper().Contains(request.Name.ToUpper()))
                {
                    productMatches.Add(product);
                }
            }
            return new SearchProductsResponse(productMatches);
        }

        #endregion
    }
}
